from jarray import zeros
from java.lang import Thread
from java.util import Properties, Random
from javax.jms import Session
from javax.naming import Context, InitialContext
from com.sun.jndi.fscontext import RefFSContextFactory

properties = Properties()
QCF_NAME="MQ_QCF"
Q_NAME="SOAP.TEST.Q"
PROVIDER_URL="file:///C:/JndiMQ/roger/mqjndi"

# Look up connection factory and queue in JNDI.
properties = Properties()
properties[Context.PROVIDER_URL] = PROVIDER_URL
properties[Context.INITIAL_CONTEXT_FACTORY] = RefFSContextFactory.name

initialContext = InitialContext(properties)

connectionFactory = initialContext.lookup(QCF_NAME)
queue = initialContext.lookup(Q_NAME)
initialContext.close()

# Create a connection.
connection = connectionFactory.createQueueConnection("Roger", None)
connection.start()
session = connection.createQueueSession(0, Session.AUTO_ACKNOWLEDGE)
sender = session.createSender(queue)
message = session.createTextMessage()
sender = session.createSender(queue)
for i in range(0,100):
    message.setText('<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"><soapenv:Header><env:AcmeHeader xmlns:env="http://www.acme.com/Tech/schemas/envelope/"><env:properties><env:sentAt>2006-06-07T04:03:24.356-05:00</env:sentAt><env:expiresAt>2006-06-07T04:27:24.356-05:00</env:expiresAt><env:topic>Customer</env:topic></env:properties><env:endpoints><env:to>MYAPPL</env:to><env:from>XYZ</env:from></env:endpoints><env:Request><env:ReplyTo>XYZ</env:ReplyTo><env:Correlate>278967b3-533a-431b-bb9e-93ed7e645a93</env:Correlate></env:Request></env:AcmeHeader></soapenv:Header><soapenv:Body><env:AcmeBody xmlns:env="http://www.acme.com/Tech/schemas/envelope/"><!-- Retrieve 1 record --><GetCustomer xmlns:myAppl="myAppl.acme.com" xmlns:rs="myAppl.acme.com/RequestSpecification" xmlns:sm="myAppl.acme.com/SystemMapping" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="http://127.0.0.1/XMLRep/MYAPPL_Interfaces/GetCustomer.xsd" version="1"><RequestControl><OptionalProcessing>H</OptionalProcessing><OptionalProcessing>K</OptionalProcessing><OptionalProcessing>L</OptionalProcessing></RequestControl><RequestorDetails><Division>MYAPPL</Division><LineOfBusiness>MYAPPL Development</LineOfBusiness><Application>MYAPPL Test Harness</Application><Area>Test</Area></RequestorDetails><CustomerSystemMapping><SourceSystem>XYZ</SourceSystem><ID>ABCD</ID></CustomerSystemMapping></GetCustomer></env:AcmeBody></soapenv:Body></soapenv:Envelope>')
    message.setJMSCorrelationID("AAAAAAAAAAAAA-%s"  %i)
    message.setJMSMessageID("%s" %i)
    print "Message id ", i
    Thread.sleep(250)
    sender.send(message)
    print message.JMSMessageID

connection.close()
